package com.surekam.jsoup;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.htmlparser.NodeFilter;
import org.htmlparser.Parser;
import org.htmlparser.Tag;
import org.htmlparser.filters.TagNameFilter;
import org.htmlparser.tags.LinkTag;
import org.htmlparser.util.NodeList;
import org.htmlparser.util.ParserException;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.jsoup.select.Elements;

import com.surekam.dao.DateUtil;
import com.surekam.model.ParamModel;

public class MainAction {

	public static void main(String[] args) throws IOException {
		File dir = new File("G:\\test\\local\\www.stats.gov.cn");
		File [] files = readFiles(dir);
		for (File file : files) {
			startAction(file);
		}
		
	}
	
	public static void startAction(File file) throws IOException{
		FileReader fr = null;
		StringBuffer sb = new StringBuffer();
		try {
			fr = new FileReader(file);
			char[] buf = new char[1024];
			int len = 0;
			while ((len = fr.read(buf)) != -1) {
				sb.append(new String(buf, 0, len));
			}
		} catch (FileNotFoundException e1) {
			e1.printStackTrace();
		} finally {
			fr.close();
		}
		int fileName = file.getName().length();
		String fileNametemp [] = file.getName().split("\\.");
		String anaylisisHtml = null;
		String type = null;
		if(fileName == 9){
			anaylisisHtml = anayli(sb.toString(), ".countytable");
			type=".countytable";
		}else if(fileName == 11) {
			anaylisisHtml = anayli(sb.toString(), ".towntable");
			type=".towntable";
		}else if(fileName == 14){
			anaylisisHtml = anayli(sb.toString(), ".villagetr");
			type=".villagetr";
		}
		
		
		List<String> list = getPageLinks(anaylisisHtml,type);
		List<ParamModel> models = new ArrayList<>();
		if(type.equals(".villagetr")){
			for (int i = 0; i < list.size(); i = i + 3) {
				System.out.println(fileNametemp[0]+"   "+ list.get(i) + "  " + list.get(i+2));
				ParamModel model = new ParamModel();
				model.setFileName(fileNametemp[0]);
				model.setObj1(list.get(i));
				model.setObj2(list.get(i+2));
				models.add(model);
			}
			try {
				//DateUtil.save(models);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}else{
			for (int i = 0; i < list.size(); i = i+2) {
				System.out.println(fileNametemp[0]+"   "+ list.get(i) + "  " + list.get(i+1));
				ParamModel model = new ParamModel();
				model.setFileName(fileNametemp[0]);
				model.setObj1(list.get(i));
				model.setObj2(list.get(i+1));
				models.add(model);
			}
			try {
				//DateUtil.save(models);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}
		
		
	}
	
	/**
	 * õļµļ
	 * @param dir
	 */
	public static File [] readFiles(File dir){
		File [] files = dir.listFiles();
		return files;
	}
	
	/**
	 * classˣع˺classڵhtmlԪ
	 * @param html
	 * @param choClass
	 * @return
	 */
	public static String anayli(String html,String choClass){
		Document doc = Jsoup.parse(html);
		Elements el = doc.select(choClass);
		return el.toString();
	}
	
	
	protected static List<String> getPageLinks(String html,String type) {
		Parser parser = null;
		NodeList nodeList = null;
		NodeFilter filter = null;
		List<String> urlList = new ArrayList<String>();
		try {
			// ָParser
			parser = Parser.createParser(html, "GB18030");
			// һܱǩAĹ
			if(type.equals(".villagetr")){
				filter = new TagNameFilter("td");
			}else {
				filter = new TagNameFilter("A");
			}
			// ˽ڵ
			nodeList = parser.extractAllNodesThatMatch(filter);
			int size = nodeList.size();
			for (int i = 0; i < size; i++) {
				if(type.equals(".villagetr")){
					Tag tag = (Tag) nodeList.elementAt(i);
					//String temStr = tag.getFirstChild().toHtml();
					urlList.add(tag.getFirstChild().toHtml());
				}else{
					LinkTag tag = (LinkTag) nodeList.elementAt(i);
					//System.out.println(tag.getLink());
					//System.out.println(tag.getChildrenHTML());
					urlList.add(tag.getChildrenHTML());
				}
			}
		} catch (ParserException e) {
			e.printStackTrace();
		}
		return urlList;
	}
}
